module CTownMode;
import std.algorithm, std.math;
import Obelisk.CColour, Obelisk.EKey, Obelisk.IObelisk;
import CGameController, IGameMode;

class CTownMode : IGameMode
{
	private IObelisk mObelisk;
	private string mTextureName;
	private string mTitle;
	private int mTitleTime = 0;

	public this(IObelisk aObelisk, string aTextureName, string aTitle = "")
	{
		mObelisk = aObelisk;
		mTextureName = aTextureName;
		mTitle = aTitle;
		mObelisk.SetBackgroundColour(new CColour(0, 0, 0));
	}



	public void Update(CGameController aGame)
	{
		if (mTitle != "")
		{
			if (mObelisk.IsKeyPressed(EKey.Enter) || ++mTitleTime == 4 * 50)
			{
				mTitle = "";
				aGame.GameNext();
			}
		}
	}



	public void Render()
	{
		mObelisk.DrawSprite(mObelisk.GetTexture(mTextureName), 0, 0);

		mObelisk.TextBegin(400, 250, 0.5);
		mObelisk.TextSetFont("Berylium.ttf", 200);
		mObelisk.SetColour(new CColour(0xdddddd));
		mObelisk.SetAlpha(min(1, cast(float)mTitleTime / (1 * 50)));
		mObelisk.TextWrite(mTitle);
		mObelisk.SetAlpha(1);
		mObelisk.SetColour(new CColour(1, 1, 1));
		mObelisk.TextEnd();
	}
}